{*******************************************************************************
  HiAsm stamp component builder v0.8 (autor - andrestudio <andrestudio@list.ru>)
  Component - SscanF
  Version - 1.0
  Autor - andrestudio
  E-mail - andrestudio@list.ru
  Create - , 26.  2016, 12:09:46
  Description:  -      
*******************************************************************************}

unit hiSscanF;

interface

uses
  Windows,Kol,Share,debug;

type
 THISscanF = class(TDebug)
   private
   { Var methods variable }

   {     }
     fCount: Word;
     fCountNew: Word;
     Err: integer;

   {      string }
     fBufferStr: Word;

   { Property variable  }
     {      }
     fMask: string;
     {  MT     onResult = True, False 
     nil }
     fMTEnabled: boolean;

     procedure SetCount(value: Word);

   public

   { Event points }
   {          MT 
      MTEnabled = True }
     _event_onResultMT: THI_Event;
   {        }
     _event_onError: THI_Event;

   { Data points}
     {       }
     _data_Str: THI_Event;
     {        doSscanF }
     _data_Mask: THI_Event;
     {     string  }
     _data_BufferStr: THI_Event;

   { Methods }
     {       }
     procedure _work_doSscanF(var _Data: TData; Index: Word);
     function SscanF(StrIn,StrFmt: PChar): integer;
     procedure Value(var _Data:TData; Index: Word);

   { Methods from property }
     {      }
     procedure _work_doMask(var _Data: TData; Index: Word);
     {       String }
     procedure _work_doBufferStr(var _Data: TData; Index: Word);


   { Property }
     {      }
     property _prop_Mask: string  read fMask  write fMask;
     {  MT     onResult = True, False 
     nil }
     property _prop_MTEnabled: boolean  read fMTEnabled  write fMTEnabled;
     {    }
     property _prop_Count: word  read fCount write SetCount;

     property _prop_BufferStr: word  read fBufferStr write fBufferStr;

  end;

implementation

const
  STRING_BUF: Integer = 255;  //    string

var
  Param: PStream;
  ArrDt: array of TData;
  ArrLength: dword; //     

//     
//    run nime error     dll.
// (      THISscanF.SscanF)
function SetArrayDataLength(const Fmt: string): integer;
var i,j,count: integer;
begin
  count := 0; Result := 0;
  for i := 1  to Length(Fmt) do
  begin
    case Fmt[i] of
      '%': begin
             for j := i+1 to Length(Fmt) do
             begin
               case Fmt[j] of
                 's','c','[':             begin Inc(count); Break; end;
                 'f','e','F','E':         begin Inc(count); Break; end;
                 'u','n','x','X','i','d': begin Inc(count); Break; end;
                 '%','*': Break;
               end;
             end;
           end;
    end;
  end;
  SetLength(ArrDt,count);
  Result := count;
end;

procedure THISscanF.SetCount;
var
  i: Integer;
begin
  SetLength(ArrDt, Value);
  for i := 0 to High(ArrDt) do
    ArrDt[i] := _Data_Empty;
  fCount := Value;
end;


//        
function THISscanF.SscanF(StrIn,StrFmt: PChar): integer;
var
  i,j,CallType,ParamSize: Integer;
  Func: Pointer;
  DLLHandle: THandle;
  tmpPtr: Pointer;
begin
  CallType := 1; ParamSize := 0; Result := -1;
  //     
  DLLHandle := LoadLibrary('msvcrt.dll');
  //DLLHandle := LoadLibrary('pncrt.dll');
  Func := GetProcAddress(DLLHandle, 'sscanf');
  if Func = nil then Exit;
  //     
  Param := NewMemoryStream;
  //  
  Param.Write(StrIn, 4);
  Param.Write(StrFmt, 4);
  //     
  for i := 1  to Length(StrFmt) do
  begin
    case StrFmt[i] of
      '%': begin
             for j := i+1 to Length(StrFmt) do
             begin
               case StrFmt[j] of
                 's','c','[':
                          begin
                            ArrDt[ArrLength].Data_type := data_str;
                            //        PChar
                            GetMem(Pointer(ArrDt[ArrLength].idata), STRING_BUF);
                            tmpPtr := PChar(ArrDt[ArrLength].idata);
                            Param.Write(tmpPtr, 4);
                            Inc(ArrLength);
                            Break;
                          end;
                 'f','e','F','E':
                          begin
                            ArrDt[ArrLength].Data_type := data_real;
                            tmpPtr := @ArrDt[ArrLength].rdata;
                            Param.Write(tmpPtr, 4);
                            Inc(ArrLength);
                            Break;
                          end;
                 'u','n','x','X','i','d':
                          begin
                            ArrDt[ArrLength].Data_type := data_int;
                            tmpPtr := @ArrDt[ArrLength].idata;
                            Param.Write(tmpPtr, 4);
                            Inc(ArrLength);
                            Break;
                          end;
                 '%','*': Break; // '*'  .   

               end; // case StrFmt[j]
             end;  // for j
           end;
    end;
  end;

  //         sscanf
  if ArrLength > 0 then
  begin
    ParamSize:=Param.Size;
    //  
    tmpPtr := Pointer(cardinal(Param.Memory) + (Param.Size - 4));
    //      
    asm
        mov eax,0
        mov ecx, [ParamSize]
        cmp ecx, 0    //   
        jle @gofunc
        mov ecx,0
        @lab:
        mov ebx, [tmpPtr]
        mov ebx,[ebx]
        push ebx
        sub [tmpPtr], 4
        add ecx, 4
        cmp ecx, [ParamSize]
        jne @lab
        @gofunc:
        call [Func]
        mov  dword ptr [Result], eax
        mov ecx, [CallType]
        cmp ecx, 0
        jle @endfunc
        add esp, [ParamSize] //  cdecl
        @endfunc:
    end;

  Param.Free;
  Func := nil;
  tmpPtr := nil;

  end else Exit;

   //   ArrDt string
  for i := 0 to High(ArrDt) do
    begin
     if _IsStr(ArrDt[i]) then
       begin
         dtString(ArrDt[i],(PChar(ArrDt[i].idata)));
         //ArrDt[i].sdata := (PChar(ArrDt[i].idata));
         Finalize(PChar(ArrDt[i].idata));
         FreeMem(PChar(ArrDt[i].idata));
         ArrDt[i].idata := 0;
       end;
    end;
end;

{       }
procedure THISscanF._work_doSscanF;
var
  inStr,inFmt: string;
  i: integer;
  ndt: TData; sp:PData;
begin
  ArrLength := 0;

  STRING_BUF := ReadInteger(_Data, _data_BufferStr, _prop_BufferStr);
  inStr := ReadString(_Data, _data_Str);
  //inFmt := ReadString(_Data, _data_Mask, _prop_Mask);
  //   ,    !!!
  inFmt := ' ' + ReadString(_Data, _data_Mask, _prop_Mask);

  //         ( MT )
  fCountNew := SetArrayDataLength(inFmt);
  //   
  for i := 0 to High(ArrDt) do
    ArrDt[i] := _data_Empty;
  //  SscanF
  Err := SscanF(PChar(inStr),PChar(inFmt));
  //   onError -1    
  //    
  _hi_onEvent(_event_onError, Err);

  //      !!!
  if Err > 0 then
  begin
    //      
    if _prop_MTEnabled then
       begin
         dtNull(ndt);
         //for i := 0 to High(ArrDt) do
         for i := 0 to Err-1 do
           AddMTData(@ndt,@ArrDt[i],sp);
         //     onResultMT
         _hi_onEvent_(_event_onResultMT,ndt);
         FreeData(@ndt);
         //   NULL onResultMT
       end else _hi_onEvent(_event_onResultMT);
  end;
end;

{      }
procedure THISscanF._work_doMask;
begin
  _prop_Mask := ToString(_Data);
end;

{       String }
procedure THISscanF._work_doBufferStr;
begin
  _prop_BufferStr := ToInteger(_Data);
end;

{      }
procedure THISscanF.Value;
begin
  if index <= Err-1 then
    dtData(_Data, ArrDt[index])
  else dtNull(_Data);
end;


end.
